﻿using gridWithCombo.Models;
using Infragistics.Web.Mvc;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Web;
using System.Web.Mvc;

namespace gridWithCombo.Controllers
{
    public class HomeController : Controller
    {
        //
        // GET: /Home/

        public ActionResult Index()
        {
            return View();
        }
        public ActionResult Edit(int id)
        {
            // Load the data from the JSON data file and deserialize it to a list.
            System.IO.StreamReader reader = new System.IO.StreamReader(Server.MapPath("/JSON/TestData_ClearanceRequest.json"));
            string jsonString = reader.ReadToEnd();
            reader.Close();

            System.Web.Script.Serialization.JavaScriptSerializer serializer = new System.Web.Script.Serialization.JavaScriptSerializer();
            List<ClearanceRequest> clearanceRequests = serializer.Deserialize<List<ClearanceRequest>>(jsonString);

            // Find the ClearanceRequest with the matching ID from the list.
            ClearanceRequest clearanceRequest = clearanceRequests.Find(request => request.ID == id);

            if (clearanceRequest == null)
                return new HttpStatusCodeResult(HttpStatusCode.NotFound);

            if (clearanceRequest.ShipmentMeasurements == null)
                clearanceRequest.ShipmentMeasurements = new List<ShipmentMeasurement>();

            return View(clearanceRequest);
        }

        [HttpPost]     
        public ActionResult Edit(ClearanceRequest clearanceRequest)
        {
            if (ModelState.IsValid)
            {
                // Save the changes to the Clearance Request.
                //AddAlert(PageAlertStyles.Success, "<span class=\"glyphicon glyphicon-floppy-saved\"></span> Changes Saved Successfully", true);
                return RedirectToAction("Index");
            }

            return View(clearanceRequest);
        }

        [GridDataSourceAction]
        public ActionResult GetShipmentMeasurements()
        {
            // Load the data from the JSON data file and deserialize it to a list.
            System.IO.StreamReader reader = new System.IO.StreamReader(Server.MapPath("/JSON/TestData_ClearanceRequest.json"));
            string jsonString = reader.ReadToEnd();
            reader.Close();

            System.Web.Script.Serialization.JavaScriptSerializer serializer = new System.Web.Script.Serialization.JavaScriptSerializer();
            List<ClearanceRequest> clearanceRequests = serializer.Deserialize<List<ClearanceRequest>>(jsonString);

            // Find the ClearanceRequest with the matching ID from the list.
            ClearanceRequest clearanceRequest = clearanceRequests.FirstOrDefault();

            return View(clearanceRequest.ShipmentMeasurements.AsQueryable());
        }

        [ComboDataSourceAction]
        public ActionResult GetSidesForDropdown()
        {
            List<MeasurementSide> sides = new List<MeasurementSide>();

            MeasurementSide sideBoth = new MeasurementSide();
            sideBoth.Code = "B";
            sideBoth.Name = "Both";

            MeasurementSide sideLeft = new MeasurementSide();
            sideLeft.Code = "L";
            sideLeft.Name = "Left";

            MeasurementSide sideRight = new MeasurementSide();
            sideRight.Code = "R";
            sideRight.Name = "Right";

            sides.Add(sideBoth);
            sides.Add(sideLeft);
            sides.Add(sideRight);

            return View(sides);
        }

        [HttpPost]       
        public JsonResult GetSidesForArray()
        {
            List<MeasurementSide> sides = new List<MeasurementSide>();

            MeasurementSide sideBoth = new MeasurementSide();
            sideBoth.Code = "B";
            sideBoth.Name = "Both";

            MeasurementSide sideLeft = new MeasurementSide();
            sideLeft.Code = "L";
            sideLeft.Name = "Left";

            MeasurementSide sideRight = new MeasurementSide();
            sideRight.Code = "R";
            sideRight.Name = "Right";

            sides.Add(sideBoth);
            sides.Add(sideLeft);
            sides.Add(sideRight);

            return Json(sides);
        }
    }
}
